*-----------------------------------------------------------
* Title         : DoDonPachi III / DoDonPachi Dai-Ou-Jou / DoDonPachi Dai-Ou-Jou Black Label protection simulation
* Written by    : IQ_132
* Date          : 2021-2022
* Description   : Simulate the protection routines required by this game in 68k assembly
*-----------------------------------------------------------
    ORG    $100400
START:                  ; first instruction of program

_unused_ram         equ     $81e01a
_unused_ram2        equ     $81e420

_slots			    equ	    _unused_ram	        ; 400 bytes
_sim_value		    equ	    _unused_ram2        ; 2 bytes
_slot_select		equ	    _unused_ram2+$4     ; 2 bytes
_response		    equ	    _unused_ram2+$8     ; 4 bytes
_key                equ     _unused_ram2+$c     ; 4 bytes

    bra.s         _protection_routine_D0          ; 200

_protection_routine_80380e                        ; 202
    movem.l     D0-D2/A0, -(A7)
    move.w	    $80380e, D0
    bra.s _protection_routine

_protection_routine_D0
    movem.l     D0-D2/A0, -(A7)

_protection_routine
    ; is key ff?
    move.w      D0, D1
    lsr.w       #$8, D1
    cmp.b       #$ff, D1
    bne.s       _skip_calc_key_ff
    move.l      #$ffffffff, _key
_skip_calc_key_ff
    move.w      _key, D1

    ; apply key to command
    eor.b       D1, D0
    andi.w      #$ff, D0

    ; apply key to sim value
	move.w      _sim_value, D2
	eor.w       D1, D2
	move.w      D2, _sim_value

	move.l		#$880000, _response

	cmp.b		#$99, D0
	beq.s		_99_routine
	cmp.b		#$8e, D0
	beq		    _8e_routine
	cmp.b		#$67, D0
	beq		    _67_routine
	cmp.b       #$e5, D0
	beq         _e5_routine	
	cmp.b		#$40, D0
	beq.s		_40_routine

_end_protection_routine
    moveq.l     #$0, D0    ; update key!
    moveq.l     #$0, D1
    move.b      _key, D0
    add.w       #$1, D0
    andi.w      #$ff, D0
    cmpi.b      #$ff, D0
    bne.s       _skip_reset_key
    moveq.l     #$1, D0
_skip_reset_key
    move.b      D0, D1
    lsl.w       #$8, D0
    move.b      D1, D0
    move.w      D0, D1
    swap        D0
    move.w      D1, D0
    move.l      D0, _key
    move.l      _response, D1 ; apply key to response!
    eor.l       D0, D1
    move.l      D1, _response
    movem.l     (A7)+, D0-D2/A0
	rts

_99_routine
    move.l      #$0, _key
	bra.s       _end_protection_routine

_40_routine
	lea.l		_slots, A0
	move.w		_sim_value, D0
	move.w		D0, D1
	move.w		D0, D2
	andi.w		#$1f, D0		; sim_value & 1f
	andi.w		#$3e0, D1	; sim_value >> 5) & 1f
	andi.w		#$7c00, D2	; sim_value >> 10) & 1f
	lsl.w		#$2, D0
	lsr.w		#$3, D1
	lsr.w		#$8, D2
	move.l		(A0,D0.w), D0
	move.l		(A0,D1.w), D1
	add.l		D1, D0
	andi.l      #$ffffff, D0
	move.l		D0, (A0,D2)
	bra         _end_protection_routine

_e5_routine
	move.w		_slot_select, D0
	lea.l		_slots, A0
	move.l		(A0,D0.w), D1
	move.w		_sim_value, D1
	move.l		D1, (A0,D0.w)
	bra         _end_protection_routine

_67_routine
	move.w		_sim_value, D0
	andi.w      #$ff00, D0
	lsr.w		#$6, D0
	move.w		D0, _slot_select
	lea.l		_slots, A0
	move.l		(A0,D0.w), D1
	swap		D1
	move.w		_sim_value, D1
	andi.w		#$ff, D1
	swap		D1
	move.l		D1, (A0,D0.w)
	bra         _end_protection_routine

_8e_routine
	move.w		_sim_value, D0
	andi.w		#$ff, D0
	lsl.w		#$2, D0
	lea.l		_slots, A0
	move.l		(A0,D0.w), _response
	bra         _end_protection_routine

    END    START        ; last line of source

*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~4~
